﻿$(document).ready(function () {

    // Event hander for radio button exchange selection
    $("#radioEmailServerExchange").click(function () {

        var selectedExchange = $('#radioEmailServerExchange:selected').prop('selected');
        if (selectedExchange != undefined) {
            $("#EmailServerExchange").hide(250);
            $("#EmailServerSMTP").show(250);
        }
        else {
            $("#EmailServerExchange").show(250);
            $("#EmailServerSMTP").hide(250);
        }

    })
    // Event hander for radio button IMAP selection
    $("#radioEmailServerSMTP").click(function () {

        var selectedIMAP = $('#radioEmailServerSMTP:selected').prop('selected');
        if (selectedIMAP != undefined) {
            $("#EmailServerExchange").show(250);
            $("#EmailServerSMTP").hide(250);
        }
        else {
            $("#EmailServerExchange").hide(250);
            $("#EmailServerSMTP").show(250);
        }

    })
    var EmailServerExchangeSelected = $('#radioEmailServerExchange:checked').prop('checked');
    var EmailServerSMTPSelected = $('#radioEmailServerSMTP:checked').prop('checked');
    if (EmailServerExchangeSelected != undefined) {
        $("#EmailServerExchange").show();
        $("#EmailServerSMTP").hide();
    }
    if (EmailServerSMTPSelected != undefined) {
        $("#EmailServerExchange").hide();
        $("#EmailServerSMTP").show();
    }


    // Event handler for selection of GWA enable or disable
    $("#checkBoxEnableSyslog").click(function () {

        var satisfied = $('#checkBoxEnableSyslog:checked').prop('checked');
        if (satisfied != undefined && satisfied != false) {
            $("#SyslogConf").show(250);
        }
        else {
            $("#SyslogConf").hide(250);
        }

    })

    var isSyslogEnabled = $('#checkBoxEnableSyslog:checked').prop('checked');
    if (isSyslogEnabled != undefined && isSyslogEnabled != false) {
        $("#SyslogConf").show();
    }
    else {
        $("#SyslogConf").hide();
    }


    // Event handler for selection of GWA enable or disable
    $("#checkBoxAuthentication").click(function () {

        var satisfied = $('#checkBoxAuthentication:checked').prop('checked');
        if (satisfied != undefined && satisfied != false) {
            $("#Authentication").show(250);
        }
        else {
            $("#Authentication").hide(250);
        }

    })

    var isSyslogEnabled = $('#checkBoxAuthentication:checked').prop('checked');
    if (isSyslogEnabled != undefined && isSyslogEnabled != false) {
        $("#Authentication").show();
    }
    else {
        $("#Authentication").hide();
    }




    // Event handler for selection of GSS Folder authentication enable or disable
    $("#checkBoxGSSAuthentication").click(function () {

        var satisfied = $('#checkBoxGSSAuthentication:checked').prop('checked');
        if (satisfied != undefined && satisfied != false) {
            $("#GSSAuthentication").show(250);
        }
        else {
            $("#GSSAuthentication").hide(250);
        }

    })

    var isSyslogEnabled = $('#checkBoxGSSAuthentication:checked').prop('checked');
    if (isSyslogEnabled != undefined && isSyslogEnabled != false) {
        $("#GSSAuthentication").show();
    }
    else {
        $("#GSSAuthentication").hide();
    }


    $("#checkChangePassword").click(function () {

        var satisfied = $('#checkChangePassword:checked').prop('checked');
        if (satisfied != undefined) {
            $("#passwordLine").show(250);
        }
        else {
            $("#passwordLine").hide(250);
        }

    });
    $("#checkChangePasswordForSMTP").click(function () {

        var satisfied = $('#checkChangePasswordForSMTP:checked').prop('checked');
        if (satisfied != undefined) {
            $("#passwordLineForSMTP").show(250);
        }
        else {
            $("#passwordLineForSMTP").hide(250);
        }

    });
    $("#checkChangePasswordForPKI").click(function () {

        var satisfied = $('#checkChangePasswordForPKI:checked').prop('checked');
        if (satisfied != undefined) {
            $("#passwordLineForPKI").show(250);
        }
        else {
            $("#passwordLineForPKI").hide(250);
        }

    });

    $("#azureCheckChangePasswordForPKI").click(function () {

        var satisfied = $('#azureCheckChangePasswordForPKI:checked').prop('checked');
        if (satisfied != undefined) {
            $("#azurePasswordLineForPKI").show(250);
        }
        else {
            $("#azurePasswordLineForPKI").hide(250);
        }

    });

    $("#checkChangePasswordForADServicePassword").click(function () {

        var satisfied = $('#checkChangePasswordForADServicePassword:checked').prop('checked');
        if (satisfied != undefined) {
            $("#passwordLineForSMTPADServicePassword").show(250);
        }
        else {
            $("#passwordLineForSMTPADServicePassword").hide(250);
        }

    });

   


    if (nPasswordPresent == 1) {
        $("#passwordLine").hide();
        $("#changePasswordCheck").show()
    }
    else {
        $("#passwordLine").show();
        $("#changePasswordCheck").hide()
    };
    if (nSMTPPasswordPresent == 1) {
        $("#passwordLineForSMTP").hide();
        $("#changePasswordCheckForSMTP").show()
    }
    else {
        $("#passwordLineForSMTP").show();
        $("#changePasswordCheckForSMTP").hide()
    };

    if (nPKICertPasswordPresent == 1) {
        $("#passwordLineForPKI").hide();
        $("#changePasswordCheckForPKI").show()
    }
    else {
        $("#passwordLineForPKI").show();
        $("#changePasswordCheckForPKI").hide()
    };

    if (nAzureADPKICertPasswordPresent == 1) {
        $("#azurePasswordLineForPKI").hide();
        $("#azureChangePasswordCheckForPKI").show()
    }
    else {
        $("#azurePasswordLineForPKI").show();
        $("#azureChangePasswordCheckForPKI").hide()
    };


    if (nADServiceAccountPasswordPresent == 1) {
        $("#passwordLineForSMTPADServicePassword").hide();
        $("#changePasswordCheckForADServicePassword").show()
    }
    else {
        $("#passwordLineForSMTPADServicePassword").show();
        $("#changePasswordCheckForADServicePassword").hide()
    };

 


    $('#btnSendTestMail').click(function () {
        var _emailservertype = "0";
        var selectedVal = "";
        var selected = $("#radioEmailServerSMTP:checked");
        if (selected.length > 0) {
            _emailservertype = "1";
        }
        var _exchange_url = $("#exchange_url").val();
        var _exchange_user = $("#exchange_user").val();
        var _exchange_secured_password = $("#exchange_secured_password").val();
        var _smtpserver = $("#smtpserver").val();
        var _smtpport = $("#smtpport").val();
        var _smtploginid = $("#smtploginid").val();
        var _smtp_secured_password = $("#smtp_secured_password").val();
        var _smtpissecured = $("#smtpissecured").is(':checked');
        var _smtp_mail_from = $("#smtp_mail_from").val();
        var _smtp_mail_from_displayName = $("#smtp_mail_from_displayName").val();
        var _send_test_email_to = $("#testEmail").val();
        fnTestMailServer(
            _emailservertype,
            _exchange_url,
            _exchange_user,
            _exchange_secured_password,
            _smtpserver,
            _smtpport,
            _smtploginid,
            _smtp_secured_password,
            _smtpissecured,
            _smtp_mail_from,
            _smtp_mail_from_displayName,
            _send_test_email_to
            );
    });


    $("#radioGalaxkey").click(function () {
        $("#authActiveDirectory").hide(250);
        $("#authOkta").hide(250);
        $("#authAzureAD").hide(250);
    });

    $("#radioActiveDirectory").click(function () {
        $("#authActiveDirectory").show(250);
        $("#authOkta").hide(250);
        $("#authAzureAD").hide(250);
    });

    $("#radioOkta").click(function () {
        $("#authActiveDirectory").hide(250);
        $("#authOkta").show(250);
        $("#authAzureAD").hide(250);
    });

    $("#radioAzureAD").click(function () {
        $("#authActiveDirectory").hide(250);
        $("#authOkta").hide(250);
        $("#authAzureAD").show(250);
    });

    var authMode = 0;
    var selected = $("input[name=authenticationType]:checked");
    if (selected.length > 0) {
        authMode = selected.val();
    }
    if (authMode == 0 || authMode == undefined)
    {
        $("#authActiveDirectory").hide(250);
        $("#authOkta").hide(250);
        $("#authAzureAD").hide(250);
    }
    else if (authMode == 1) {
        $("#authActiveDirectory").show(250);
        $("#authOkta").hide(250);
        $("#authAzureAD").hide(250);
    }
    else if (authMode == 2) {
        $("#authActiveDirectory").hide(250);
        $("#authOkta").show(250);
        $("#authAzureAD").hide(250);
    }
    else if (authMode == 3) {
        $("#authActiveDirectory").hide(250);
        $("#authOkta").hide(250);
        $("#authAzureAD").show(250);
    }



});


function fnTestMailServer(
    _emailservertype,
    _exchange_url,
    _exchange_user,
    _exchange_secured_password,
    _smtpserver,
    _smtpport,
    _smtploginid,
    _smtp_secured_password,
    _smtpissecured,
    _smtp_mail_from,
    _smtp_mail_from_displayName,
    _send_test_email_to
    ) {
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');


    var jSonData = {
        _emailservertype: _emailservertype,
        _exchange_url: _exchange_url,
        _exchange_user: _exchange_user,
        _exchange_secured_password: _exchange_secured_password,
        _smtpserver: _smtpserver,
        _smtpport: _smtpport,
        _smtploginid: _smtploginid,
        _smtp_secured_password: _smtp_secured_password,
        _smtpissecured: _smtpissecured,
        _smtp_mail_from: _smtp_mail_from,
        _smtp_mail_from_displayName: _smtp_mail_from_displayName,
        _send_test_email_to: _send_test_email_to
    };

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: '/HybridConfiguration/SendTestEmail',
        data: jSonData,
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var strResult = jSon['result'];
                if (Boolean(eval(strResult.toLowerCase())) == false) {
                    webix.alert(jSon['message']);
                }
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            webix.alert("Status: " + textStatus);
            webix.alert("Error: " + errorThrown);
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
};